/* ȿñ㲻ġ
 * shige
 * 11/06 2000
 * auhz.c
 *
 * $Id: auhz.c,v 1.4 2001-02-28 20:54:26+09 shige Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "sndio.h"
#include "g711.h"

#define MaxInt16 32767
#define RATE 8000
#define USESINEWAVE
#define uns(s) ((unsigned char *)(s))
#define str4byte2x(s) (uns(s)[0]<<24|uns(s)[1]<<16|uns(s)[2]<<8|uns(s)[3])

int main(int argc,char *argv[]);
void putnullsound(FILE *outfile,Snddata *snd);
void putsound(FILE *outfile,Snddata *snd,int hz,double vol);
double periodic(double x);
void usage(void);

int main(int argc,char *argv[])
{
    FILE *outfile=stdout;
    int hz,len;
    double vol;
    Snddata snd={
        0,      /* magic number */
        32,     /* data  offset */
        0,      /* data Ĺ */
        1,      /* data format code (1= 8bit mu-low) */
        RATE,   /* sampling rate */
        1,      /* cannel  */
        NULL
    };

    if(argc!=3+1 ||(hz=atoi(argv[1]))<0
       ||(len=atoi(argv[2]))<=0
       ||(vol=atof(argv[3]))<0.0 || vol>1.0){
	usage();
	return 0;
    }
    snd.magic=str4byte2x(".snd");
    snd.datalen=(int)((double)len*RATE/1000.0+0.5);
    putsound(outfile,&snd,hz,vol);
    return 0;
}

/* hz Hz, len ߥäβ volume level vol ή
 * hz == 0 ==> ̵
 */
void putsound(FILE *outfile,Snddata *snd,int hz,double vol)
{
    int j;
    double y;

    putallheader(outfile,snd,1);
    if(hz==0 || vol==0.0)
      for(j=1;j<=snd->datalen;j++) 
	fputc(AUNULL,outfile);
    else
      for(j=1;j<=snd->datalen;j++){
	  y=vol*MaxInt16*periodic((double)j*hz/RATE);
	  fputc(linear2ulaw(y),outfile);
      }
}

#ifdef USESINEWAVE
/*  1,  -1.0~1.0
 */
double periodic(double x)
{
    return sin(2.0*M_PI*x);
}
#else
double periodic(double x)
{
    int j;

    j=x;
    return x-j;
}
#endif

void usage(void)
{
    char *mess[]={
	"Usage: auhz [Hz] [msec] [vol] (> [newfile])",
	" [Hz]  : ñ㲻ι⤵   (ȿ)",
	" [msec]: ñ㲻Ĺ   (ߥ)",
	" [vol] : ñ㲻礭 (0.0~1.0)",
	"Ex. auhz 440 500 0.7> poo.au",
	" ==> 440Hz (), 0.5 äβ",
	" 1) Ϥɸϡ",
	" 2) [Hz] == 0 ޤ [vol] == 0 Ȥ̵Υǡ롣",
#ifdef USESINEWAVE
	" 3) ñ㲻ϻȤѤ롣",
#else
	" 3) ñ㲻ϥΥȤѤ롣",
#endif
	NULL
    };
    int j;

    for(j=0;mess[j]!=NULL;j++) fprintf(stderr,"%s\n",mess[j]);
}
