/* ե벻ץΥץȥ (au version)
 * shige
 * 10/28 2001
 * aunormal.c
 *
 * $Id: aunormal.c,v 1.3 2001-11-02 11:17:53+09 shige Exp $
 */
/* gcc -I. -DSUPERCEDED -o aunormal aunormal.c sndio.c fileio.c dist/g711.c
 */
#include <stdio.h>
#include <stdlib.h>
#include "sndio.h"
#include "g711.h"
#ifndef Max
# define Max(a,b)  (((a)>(b))?(a):(b))
#endif
#ifndef Abs
# define Abs(a)  Max((a),-(a))
#endif

int getarg(int argc,char **argv,double *vol,FILE **infile,FILE **outfile,
	   int *verbose,int *info);
void usage(void);

int main(int argc,char *argv[])
{
    Snddata sd;
    FILE *infile,*outfile;
    int j,info,verbose;
    unsigned char c;
    short int x;
    double vol,times,maxlevel;
    int max=0,ret;

    if((ret=getarg(argc,argv,&vol,&infile,&outfile,&verbose,&info))<0)
      return -ret;
    if((ret=getSndheader(infile,&sd))<0){
        fprintf(stderr,"get header error.\n");
        return -ret;
    }
    fseek(infile,sd.hlen,SEEK_SET);
    for(j=1;j<=sd.datalen;j++){
        c=fgetc(infile);
        x=ulaw2linear(c);
	if(Abs(x)>max) max=Abs(x);
    }
    maxlevel=(double)max/AUSCALE;
    if(maxlevel<=0.0) times=0.0;
    else times=vol/maxlevel;
    if(info){
	if(!verbose) fprintf(outfile,"%f %f\n",maxlevel,times);
	else fprintf(outfile,"level = %f ,  times = %f\n",maxlevel,times);
	return No_err;
    }
    putallheader(outfile,&sd,1);
    fseek(infile,sd.hlen,SEEK_SET);
    for(j=1;j<=sd.datalen;j++){
        c=fgetc(infile);
        x=ulaw2linear(c);
        x=x*times;
        c=linear2ulaw(x);
        fputc(c,outfile);
    }
    return No_err;
}

int getarg(int argc,char **argv,double *vol,FILE **infile,FILE **outfile,
	   int *verbose,int *info)
{
    char *fname;

    *verbose=0;
    *info=0;
    *outfile=NULL;
    while(--argc>0){
	if(**(++argv)=='-'){
	    if(*(++*argv)=='v') *verbose=1;
	    else if(**argv=='q') *verbose=0;
	    else if(**argv=='i') *info=1;
	    else if(**argv=='o'){
		if(*outfile!=NULL){ usage(); return Err_param; }
		if(*(++*argv)=='\0'){
		    if(--argc<=0){ usage(); return Err_param; }
		    else argv++;
		}
		fname=*argv;
		if(!strcmp(fname,"-")) *outfile=stdout;
		else if((*outfile=fopen(fname,"w"))==NULL){
		    fprintf(stderr,"File [%s] open error.\n",fname);
		    return Err_fopen;
		}
	    }
	    else if(**argv=='h' || **argv=='H' || **argv=='?'){
		usage(); return Err_help;
	    }
	    else{ usage(); return Err_param; }
	}
	else break;
    }
    if(argc!=2){ usage(); return Err_param; }
    if(*outfile==NULL) *outfile=stdout;
    if((*vol=atof(*argv))<0.0 || *vol>1.0){ usage(); return Err_param; }
    fname=*(++argv);
    /* if(!strcmp(fname,"-")) *infile=stdin; */
    if(!strcmp(fname,"-")){ usage(); return Err_param; }
    else if((*infile=fopen(fname,"r"))==NULL){
	fprintf(stderr,"File [%s] open error.\n",fname);
	return Err_fopen;
    }
    return No_err;
}

void usage(void)
{
    char *mess[]={
	"Usage: aunormal (-o [outfile]) (-i) [vol] [infile]",
	"       aunormal -h",
	" -o [outfile] : ե [outfile] ˽ (default: ɸ)",
	/* " -v : Ĺ", */
	/* " -q : Ĺ", */
	" -i : ߤΥ٥Ȥܤˤ뤫ɽ (Ϥʤ)",
	" [vol] : ̥٥ (0.0~1.0)",
	" [infile] : βե",
	"Ex. aunormal 0.8 a.au > a2.au",
	" 1) [file] κ粻̤Ĵ١줬 (粻̥٥)[vol] ",
	"    ʤ褦Ѵ롣",
	" 2) -i ꤷȤϲեν񤭽ФϤʤ",
	NULL
    };
    int j;

    for(j=0;mess[j]!=NULL;j++) fprintf(stderr,"%s\n",mess[j]);
}

