/* ե벻ץΥץȥ ()
 * shige
 * 10/29 2001
 * sndnormal.c
 *
 * $Id: sndnormal.c,v 1.2 2001-11-02 11:20:23+09 shige Exp $
 */
/* gcc -I. -o -DSUPERCEDED sndnormal sndnormal.c sndio.c wavio.c aiffio.c \
 *   fileio.c dist/g771.c dist/ToFromIEEE.c -lm
 */
/* 10/29 2001
 * 1) header ΤˤƤޤȤͤ뤬Ȥꤢϳѿ
 *    ޤȤˤ롣
 */
#include <stdio.h>
#include <stdlib.h>
#include "sndio.h"
#include "wavio.h"
#include "aiffio.h"
#ifndef Max
# define Max(a,b)  (((a)>(b))?(a):(b))
#endif
#ifndef Abs
# define Abs(a)  Max((a),-(a))
#endif
#define PathSep ('/')
enum {E_AU=0,E_WAV,E_AIFF,E_UNKNOWN};
char *Comnames[]={"aunormal","wavnormal","aiffnormal",NULL};

Snddata sd;
WAVdata wd;
AIFFdata ad;

int main(int argc,char *argv[]);
double getmaxlevel(FILE *infile,int format);
void putout(FILE *infile,FILE *outfile,int format,double times);
int chheader(int format);
int getheader(FILE *infile,int format);
int getarg(int argc,char **argv,double *vol,FILE **infile,FILE **outfile,
           int *verbose,int *info,int *format);
int getSndFormat(char *comname);
int pospath(char *name);
void usage(char *name,int format);

int main(int argc,char *argv[])
{
    FILE *infile,*outfile;
    int ret,info,format,verbose;
    double vol,times,maxlevel;

    if((ret=getarg(argc,argv,&vol,&infile,&outfile,&verbose,&info,&format))<0)
      return -ret;
    if((ret=getheader(infile,format))<0){
        fprintf(stderr,"get header error.\n");
        return -ret;
    }
    if((ret=chheader(format))<0) return -ret;
    if((maxlevel=getmaxlevel(infile,format))<0.0) return (int)(-maxlevel);
    if(maxlevel==0.0) times=0.0;
    else times=vol/maxlevel;
    if(info){
	if(!verbose) fprintf(outfile,"%f %f\n",maxlevel,times);
	else fprintf(outfile,"level = %f ,  times = %f\n",maxlevel,times);
	return No_err;
    }
    putout(infile,outfile,format,times);
    return No_err;
}

double getmaxlevel(FILE *infile,int format)
{
    int j,totalblocks;
    unsigned char uc;
    char c;
    short int x;
    int max=0;

    switch(format){
    case E_AU:
	fseek(infile,sd.hlen,SEEK_SET);
	for(j=1;j<=sd.datalen;j++){
	    uc=fgetc(infile);
	    x=ulaw2linear(uc);
	    if(Abs(x)>max) max=Abs(x);
	}
	return (double)max/AUSCALE;
    case E_WAV:
	totalblocks=(wd.datalen/wd.blocksize)*wd.channel;
	fseek(infile,wd.hlen,SEEK_SET);
	if(wd.bitpersmpl==8){ /* 8bit */
	    for(j=1;j<=totalblocks;j++){
		uc=fgetc(infile);
		if(Abs(uc-WAVPOS8bit)>max) max=Abs(uc-WAVPOS8bit);
	    }
	    return (double)max/WAVSCALE8bit;
	}
	else{ /* 16bit */
	    for(j=1;j<=totalblocks;j++){
		read2bytetolittlei(infile,&x); 
		if(Abs(x-WAVPOS16bit)>max) max=Abs(x-WAVPOS16bit);
	    }
	    return (double)max/WAVSCALE16bit;
	}
    case E_AIFF:
	fseek(infile,ad.hlen,SEEK_SET);
	totalblocks=ad.flames*ad.channel;
	if(ad.bitpersmpl==8){ /* 8bit */
	    for(j=1;j<=totalblocks;j++){
		c=fgetc(infile);
		if(Abs(c-AIFFPOS8bit)>max) max=Abs(c-AIFFPOS8bit);
	    }
	    return (double)max/AIFFSCALE8bit;
	}
	else if(ad.bitpersmpl==16){ /* 16bit */
	    for(j=1;j<=totalblocks;j++){
		read2bytetoi(infile,&x); 
		if(Abs(x-AIFFPOS16bit)>max) max=Abs(x-AIFFPOS16bit);
	    }
	    return (double)max/AIFFSCALE16bit;
	}
    default:
	return (double)Err_param;
    }
}

void putout(FILE *infile,FILE *outfile,int format,double times)
{
    int j,totalblocks;
    unsigned char uc;
    char c;
    short int x;

    switch(format){
    case E_AU:
	putallheader(outfile,&sd,1);
	fseek(infile,sd.hlen,SEEK_SET);
	for(j=1;j<=sd.datalen;j++){
	    uc=fgetc(infile);
	    x=ulaw2linear(uc);
	    x=x*times;
	    uc=linear2ulaw(x);
	    fputc(uc,outfile);
	}
	return;
    case E_WAV:
	totalblocks=(wd.datalen/wd.blocksize)*wd.channel;
	putallWAVheader(outfile,&wd,1);
	fseek(infile,wd.hlen,SEEK_SET);
	if(wd.bitpersmpl==8){ /* 8bit */
	    for(j=1;j<=totalblocks;j++){
		uc=fgetc(infile);
		uc=(uc-WAVPOS8bit)*times+WAVPOS8bit;
		fputc(uc,outfile);
	    }
	    if(wd.datalen%2) fputc('\0',outfile);
	}
	else{ /* 16bit */
	    for(j=1;j<=totalblocks;j++){
		read2bytetolittlei(infile,&x); 
		x=(x-WAVPOS16bit)*times+WAVPOS16bit;
		writelittleito2byte(outfile,x);
	    }
	}
	return; 
    case E_AIFF:
	totalblocks=ad.flames*ad.channel;
	putallAIFFheader(outfile,&ad,1);
	fseek(infile,ad.hlen,SEEK_SET);
	if(ad.bitpersmpl==8){ /* 8bit */
	    for(j=1;j<=totalblocks;j++){
		c=fgetc(infile);
		c=(c-AIFFPOS8bit)*times+AIFFPOS8bit;
		fputc(c,outfile);
	    }
	    if(ad.datalen%2) fputc('\0',outfile);
	    return;
	}
	else if(ad.bitpersmpl==16){ /* 16bit */
	    for(j=1;j<=totalblocks;j++){
		read2bytetoi(infile,&x); 
		x=(x-AIFFPOS16bit)*times+AIFFPOS16bit;
		writeito2byte(outfile,x);
	    }
	    return;
	}
    }
}

int chheader(int format)
{
    switch(format){
    case E_AU: return No_err;
    case E_WAV:
	if(wd.fmcode!=1){
	    fprintf(stderr,"This is not linear PCM data. (%d)\n",wd.fmcode);
	    return Err_param;
	}
	else return No_err;
    case E_AIFF:
	if(ad.bitpersmpl!=8 && ad.bitpersmpl!=16){
	    fprintf(stderr,"This program support only 8/16 bit/sample data.\n");
	    return Err_param;
	}
	else return No_err;
    default: return Err_param;
    }
}

int getheader(FILE *infile,int format)
{
    switch(format){
    case E_AU:
	return getSndheader(infile,&sd);
    case E_WAV:
	return getWAVheader(infile,&wd);
    case E_AIFF:
	return getAIFFheader(infile,&ad);
    default:
	return Err_param;
    }
}

int getarg(int argc,char **argv,double *vol,FILE **infile,FILE **outfile,
	   int *verbose,int *info,int *format)
{
    char *fname;
    char *comname;

    *verbose=0;
    *info=0;
    *outfile=NULL;
    comname=*argv;
    *format=getSndFormat(comname);
    while(--argc>0){
	if(**(++argv)=='-'){
	    if(*(++*argv)=='v') *verbose=1;
	    else if(**argv=='q') *verbose=0;
	    else if(**argv=='i') *info=1;
	    else if(**argv=='o'){
		if(*outfile!=NULL){ 
		    usage(comname,*format); return Err_param;
		}
		if(*(++*argv)=='\0'){
		    if(--argc<=0){ 
			usage(comname,*format); return Err_param;
		    }
		    else argv++;
		}
		fname=*argv;
		if(!strcmp(fname,"-")) *outfile=stdout;
		else if((*outfile=fopen(fname,"w"))==NULL){
		    fprintf(stderr,"File [%s] open error.\n",fname);
		    return Err_fopen;
		}
	    }
	    else if(**argv=='h' || **argv=='H' || **argv=='?'){
		usage(comname,*format); return Err_help;
	    }
	    else if(*format == E_UNKNOWN){
		if(strcmp(*argv,"au")) *format = E_AU;
		else if(strcmp(*argv,"wav")) *format = E_WAV;
		else if(strcmp(*argv,"aiff")) *format = E_AIFF;
	    }
	    else{ usage(comname,*format); return Err_param; }
	}
	else break;
    }
    if(argc!=2){ 
	usage(comname,*format); return Err_param;
    }
    if(*format == E_UNKNOWN){ 
	usage(comname,*format); return Err_param;
    }
    if(*outfile==NULL) *outfile=stdout;
    if((*vol=atof(*argv))<0.0 || *vol>1.0){ 
	usage(comname,*format); return Err_param;
    }
    fname=*(++argv);
    /* if(!strcmp(fname,"-")) *infile=stdin; */
    if(!strcmp(fname,"-")){ usage(); return Err_param; }
    else if((*infile=fopen(fname,"r"))==NULL){
	fprintf(stderr,"File [%s] open error.\n",fname); return Err_fopen;
    }
    return No_err;
}

int getSndFormat(char *comname)
{
    int pos,j;

    pos=pospath(comname);
    for(j=0;Comnames[j]!=NULL;j++)
      if(strcmp(Comnames[j],comname+pos)==0) break;
    return j;
}

int pospath(char *name)
{
    int len,j;

    if((len=strlen(name))<=0) return 0;
    for(j=len;j>0;j--) if(name[j-1]==PathSep) break;
    return j;
}

void usage(char *name,int format)
{
    fprintf(stderr,
        "Usage: %s (-o [outfile]) (-i)",name+pospath(name));
    if(format == E_UNKNOWN) fprintf(stderr," (-au|-wav|-aiff)");
    fprintf(stderr," [vol] [infile]\n");
    fprintf(stderr,
	"       %s -h",name+pospath(name));
    fprintf(stderr,
	" -o [outfile] : ե [outfile] ˽ (default: ɸ)\n");
    fprintf(stderr,
	" -i : ߤΥ٥Ȥܤˤ뤫ɽ (Ϥʤ)\n");
    if(format == E_UNKNOWN)
      fprintf(stderr," -au|-wav|-aiff : λ\n");
    fprintf(stderr,
	" [vol] : ̥٥ (0.0~1.0)\n");
    fprintf(stderr,
	" [infile] : оݲե\n");
    fprintf(stderr,
	" 1) [infile] κ粻̤Ĵ١줬 (粻̥٥)[vol] \n");
    fprintf(stderr,
	"    ʤ褦Ѵ롣\n");
    fprintf(stderr,
	" 2) -i ꤷȤϲեν񤭽ФϤʤ\n");
}
